Summary: SFS -- a secure, decentralized, global file system
Name: sfs
Version: 0.6
Release: 1
Copyright: GPL 
Group: Applications/File
Source: http://www.fs.net/download/sfs-%{version}.tar.gz 
URL: http://www.fs.net/
Packager: Kevin Fu <fubob@mit.edu> 
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot
Requires: kernel >= 2.2.14, gmp >= 2.0
#BuildPreReq: gcc3
BuildPreReq: gcc

%package servers
Summary: SFS servers.
Group: Applications/File
PreReq: sfs = %{version}-%{release}
Requires: nfs-server, db3 

%package devel
Summary: SFS development libraries and headers
Group: Applications/File
PreReq: sfs = %{version}-%{release}
Requires: db3

%description
The Self-Certifying File System (SFS) is a secure, global file system
with completely decentralized control. SFS lets you access your files
from anywhere and share them with anyone, anywhere. Anyone can set up
an SFS server, and any user can access any server from any client. SFS
lets you share files across administrative realms without involving
administrators or certification authorities.

This file includes the core files necessary for SFS clients, servers,
and development.  Optional packages include sfs-servers and sfs-devel.


%description servers
The Self-Certifying File System (SFS).

This package includes servers of SFS services such as the remote
execution (Rex), the SFS read-write server, and the SFS read-only
server.

%description devel
The Self-Certifying File System (SFS).

This package includes libraries and header files useful for development
of SFS-enabled tools.

%prep
#%setup -T -D
%setup -q

%build
if test -z "${DEBUG+set}"; then
    DEBUG=-O2
    export DEBUG
fi
#env CC=gcc3 CXX=g++3 ./configure --prefix=/usr --with-db3
env CC=gcc CXX=g++ ./configure --prefix=/usr --with-db3
make 

%install
rm -rf $RPM_BUILD_ROOT
make install-strip DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/var/sfs $RPM_BUILD_ROOT/etc/sfs $RPM_BUILD_ROOT/sfs
install -D -m 755 etc/sfscd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/sfscd
install -D -m 755 etc/sfssd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/sfssd

%clean
rm -rf $RPM_BUILD_ROOT

%pre
grep -q '^sfs:' /etc/passwd \
   || /usr/sbin/useradd -M -r -d /var/sfs -s /bin/true -c "SFS" sfs \
   || :
grep -q '^sfs:' /etc/group \
   || /usr/sbin/groupadd sfs 

%post
chkconfig --add sfscd
chown sfs.sfs /var/sfs
chown sfs.sfs /sfs
chown root.sfs /usr/lib/sfs/suidconnect
chmod g+s /usr/lib/sfs/suidconnect
chmod u+s /usr/lib/sfs/newaid
install-info --info-dir=/usr/info /usr/info/sfs.info || :

%post servers
chkconfig --add sfssd


%preun
if [ "$1" = "0" ]; then
   /etc/rc.d/init.d/sfscd stop >&2
   chkconfig --del sfscd
   install-info --info-dir=/usr/info --remove /usr/info/sfs.info || :
fi

%preun servers
if [ "$1" = "0" ]; then
   /etc/rc.d/init.d/sfssd stop >&2
   chkconfig --del sfssd
fi


%postun
if [ "$1" = "0" ]; then
   if grep -q '^sfs:.*:/var/sfs:' /etc/passwd; then
      /usr/sbin/userdel sfs
      if grep -q \^sfs: /etc/group; then
         /usr/sbin/groupdel sfs
      fi
   fi
   rm -rf /var/sfs/random_seed /var/sfs/authdb /var/sfs/sockets
fi

%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog NEWS README STANDARDS TODO
%config /usr/share/sfs/sfs_config
%config /usr/share/sfs/sfscd_config
%config /usr/share/sfs/sfssd_config
%config /usr/share/sfs/sfsauthd_config
%config /usr/share/sfs/sfs_srp_parms
%config /etc/rc.d/init.d/sfscd
/usr/man/man1/sfskey.1.gz
/usr/man/man1/rex.1.gz
/usr/man/man1/ssu.1.gz
/usr/man/man1/sfsagent.1.gz
/usr/man/man5/sfs_users.5.gz
/usr/man/man5/sfsauthd_config.5.gz
/usr/man/man5/sfscd_config.5.gz
/usr/man/man5/sfsrwsd_config.5.gz
/usr/man/man5/sfssd_config.5.gz
/usr/man/man5/sfs_config.5.gz
/usr/man/man5/sfs_srp_params.5.gz
/usr/man/man8/sfscd.8.gz
/usr/man/man8/sfssd.8.gz
/usr/man/man8/sfsauthd.8.gz
/usr/man/man8/sfsrwsd.8.gz
/usr/bin/sfsagent
/usr/bin/sfskey
/usr/bin/ssu
/usr/bin/dirsearch
/usr/bin/newaid
/usr/bin/rex
/usr/include/sfs
/usr/include/sfs.h
/usr/info/sfs.info.gz
/usr/info/sfs.info-1.gz
/usr/info/sfs.info-2.gz
/usr/lib/libsfs.a
/usr/lib/sfs
/usr/lib/sfs-%{version}/aiod
/usr/lib/sfs-%{version}/libasync.la
/usr/lib/sfs-%{version}/libasync.a
/usr/lib/sfs-%{version}/libarpc.la
/usr/lib/sfs-%{version}/libarpc.a
/usr/lib/sfs-%{version}/libsfscrypt.la
/usr/lib/sfs-%{version}/libsfscrypt.a
/usr/lib/sfs-%{version}/libsvc.la
/usr/lib/sfs-%{version}/libsvc.a
/usr/lib/sfs-%{version}/pathinfo
/usr/lib/sfs-%{version}/suidconnect
/usr/lib/sfs-%{version}/libsfsmisc.la
/usr/lib/sfs-%{version}/libsfsmisc.a
/usr/lib/sfs-%{version}/mallock.o
/usr/lib/sfs-%{version}/nfsmounter
/usr/lib/sfs-%{version}/sfsrwcd
/usr/lib/sfs-%{version}/newaid
/usr/lib/sfs-%{version}/sfsrwsd
/usr/lib/sfs-%{version}/sfsauthd
/usr/lib/sfs-%{version}/xfer
/usr/lib/sfs-%{version}/ptyd
/usr/lib/sfs-%{version}/rexd
/usr/lib/sfs-%{version}/proxy
/usr/lib/sfs-%{version}/ttyd
/usr/lib/sfs-%{version}/listen
/usr/lib/sfs-%{version}/connect
/usr/lib/sfs-%{version}/moduled
/usr/sbin/funmount
/usr/sbin/sfscd
%dir /etc/sfs
%dir /sfs
%dir /var/sfs

%files servers
%defattr(-,root,root)
%config /usr/share/sfs/sfssd_config
%config /usr/share/sfs/sfsauthd_config
%config /etc/rc.d/init.d/sfssd
#/usr/bin/sfsrodb
#/usr/bin/pulldb
/usr/sbin/sfssd
/usr/lib/sfs-%{version}/sfsrwsd
#/usr/lib/sfs-%{version}/sfsrosd
/usr/lib/sfs-%{version}/ptyd
/usr/lib/sfs-%{version}/rexd
/usr/lib/sfs-%{version}/sfsauthd
/usr/lib/sfs-%{version}/listen
/usr/lib/sfs-%{version}/proxy
/usr/lib/sfs-%{version}/ttyd


%files devel
%defattr(-,root,root)
/usr/bin/rpcc
#/usr/bin/printdb
/usr/include/sfs-%{version}/aiod.h
/usr/include/sfs-%{version}/aiod_prot.h
/usr/include/sfs-%{version}/aios.h
/usr/include/sfs-%{version}/amisc.h
/usr/include/sfs-%{version}/arena.h
/usr/include/sfs-%{version}/array.h
/usr/include/sfs-%{version}/async.h
/usr/include/sfs-%{version}/backoff.h
/usr/include/sfs-%{version}/bbuddy.h
/usr/include/sfs-%{version}/bitvec.h
/usr/include/sfs-%{version}/callback.h
/usr/include/sfs-%{version}/cbuf.h
/usr/include/sfs-%{version}/dns.h
/usr/include/sfs-%{version}/dnsparse.h
/usr/include/sfs-%{version}/err.h
/usr/include/sfs-%{version}/fdlim.h
/usr/include/sfs-%{version}/ihash.h
/usr/include/sfs-%{version}/init.h
/usr/include/sfs-%{version}/itree.h
/usr/include/sfs-%{version}/keyfunc.h
/usr/include/sfs-%{version}/list.h
/usr/include/sfs-%{version}/msb.h
/usr/include/sfs-%{version}/opnew.h
/usr/include/sfs-%{version}/parseopt.h
/usr/include/sfs-%{version}/pcre.h
/usr/include/sfs-%{version}/qhash.h
/usr/include/sfs-%{version}/refcnt.h
/usr/include/sfs-%{version}/rxx.h
/usr/include/sfs-%{version}/serial.h
/usr/include/sfs-%{version}/stllike.h
/usr/include/sfs-%{version}/str.h
/usr/include/sfs-%{version}/suio++.h
/usr/include/sfs-%{version}/sysconf.h
/usr/include/sfs-%{version}/union.h
/usr/include/sfs-%{version}/vatmpl.h
/usr/include/sfs-%{version}/vec.h
/usr/include/sfs-%{version}/rwfd.h
/usr/include/sfs-%{version}/pmap_prot.x
/usr/include/sfs-%{version}/aclnt.h
/usr/include/sfs-%{version}/arpc.h
/usr/include/sfs-%{version}/asrv.h
/usr/include/sfs-%{version}/axprt.h
/usr/include/sfs-%{version}/pmap_prot.h
/usr/include/sfs-%{version}/rpctypes.h
/usr/include/sfs-%{version}/xdr_suio.h
/usr/include/sfs-%{version}/xdrmisc.h
/usr/include/sfs-%{version}/xhinfo.h
/usr/include/sfs-%{version}/crypt_prot.x
/usr/include/sfs-%{version}/aes.h
/usr/include/sfs-%{version}/arc4.h
/usr/include/sfs-%{version}/axprt_crypt.h
/usr/include/sfs-%{version}/bench.h
/usr/include/sfs-%{version}/bigint.h
/usr/include/sfs-%{version}/blowfish.h
/usr/include/sfs-%{version}/crypt.h
/usr/include/sfs-%{version}/crypthash.h
/usr/include/sfs-%{version}/crypt_prot.h
/usr/include/sfs-%{version}/esign.h
/usr/include/sfs-%{version}/hashcash.h
/usr/include/sfs-%{version}/modalg.h
/usr/include/sfs-%{version}/password.h
/usr/include/sfs-%{version}/prime.h
/usr/include/sfs-%{version}/prng.h
/usr/include/sfs-%{version}/rabin.h
/usr/include/sfs-%{version}/seqno.h
/usr/include/sfs-%{version}/sha1.h
/usr/include/sfs-%{version}/srp.h
/usr/include/sfs-%{version}/tiger.h
/usr/include/sfs-%{version}/wmstr.h
/usr/include/sfs-%{version}/nfs_prot.x
/usr/include/sfs-%{version}/nfs3_prot.x
/usr/include/sfs-%{version}/nfs3exp_prot.x
/usr/include/sfs-%{version}/nfs3close_prot.x
/usr/include/sfs-%{version}/mount_prot.x
/usr/include/sfs-%{version}/sfs_prot.x
/usr/include/sfs-%{version}/sfsauth_prot.x
/usr/include/sfs-%{version}/sfsagent.x
/usr/include/sfs-%{version}/sfscd_prot.x
/usr/include/sfs-%{version}/nfsmounter.x
/usr/include/sfs-%{version}/sfsro_prot.x
/usr/include/sfs-%{version}/rex_prot.x
/usr/include/sfs-%{version}/nfs3_ext.x
/usr/include/sfs-%{version}/nfs_prot.h
/usr/include/sfs-%{version}/nfs3_prot.h
/usr/include/sfs-%{version}/nfs3exp_prot.h
/usr/include/sfs-%{version}/nfs3close_prot.h
/usr/include/sfs-%{version}/mount_prot.h
/usr/include/sfs-%{version}/sfs_prot.h
/usr/include/sfs-%{version}/sfsauth_prot.h
/usr/include/sfs-%{version}/sfsagent.h
/usr/include/sfs-%{version}/sfscd_prot.h
/usr/include/sfs-%{version}/nfsmounter.h
/usr/include/sfs-%{version}/sfsro_prot.h
/usr/include/sfs-%{version}/rex_prot.h
/usr/include/sfs-%{version}/sfs-internal.h
/usr/include/sfs-%{version}/afsnode.h
/usr/include/sfs-%{version}/agentconn.h
/usr/include/sfs-%{version}/agentmisc.h
/usr/include/sfs-%{version}/getfh3.h
/usr/include/sfs-%{version}/nfs3_nonnul.h
/usr/include/sfs-%{version}/nfsserv.h
/usr/include/sfs-%{version}/nfstrans.h
/usr/include/sfs-%{version}/rex.h
/usr/include/sfs-%{version}/sfsclient.h
/usr/include/sfs-%{version}/sfsconnect.h
/usr/include/sfs-%{version}/sfskeymisc.h
/usr/include/sfs-%{version}/sfsmisc.h
/usr/include/sfs-%{version}/sfsserv.h
/usr/include/sfs-%{version}/sfstty.h
/usr/include/sfs-%{version}/uvfstrans.h
/usr/include/sfs-%{version}/autoconf.h

%changelog
* Thu Jul 11 2002 Kevin Fu <fubob@mit.edu>
- Cleaned up for the recently released 0.6.  Added man pages.

* Sat May 4 2002 Kevin Fu <fubob@mit.edu>
- Cleaned up, synced with actual files in SFS 0.6 candidate

* Wed Jan 9 2002 Kevin Fu <fubob@mit.edu>
- Updated for new files in SFS 0.6 with SFSRO

* Wed Feb 9 2000 Michael Kaminsky <kaminsky@lcs.mit.edu>
- generalized to a generated autoconf file to be version independent 

* Tue Feb 8 2000 Michael Kaminsky <kaminsky@lcs.mit.edu>
- first build
