%#include "bigint.h"
%#include "chord_types.h"

enum control_stat {
  CONTROL_OK = 0,
  CONTROL_ERR = 1,
  CONTROL_DIST_NOVERIFY = 2
};

struct control_dist_arg {
  bool hostlist;
  int32_t ip;
  int32_t port;
  opaque contents<>;
};

struct control_dist_resok {
  bool bla;
};

union control_dist_res switch (control_stat status) {
 case CONTROL_OK:
   void;
 case CONTROL_DIST_NOVERIFY:
   void;
 default:
   void;
};

struct control_sync_arg {
  chord_hostname caller_name;
  int32_t caller_port;

  int32_t hostlistver;
  chord_hostname node_ips<>;
  int32_t node_ports<>;
  int32_t versions<>;
};

struct control_sync_resok {
  chord_hostname resp_name;
  int32_t resp_port;

  int32_t hostlistver;
  chord_hostname node_ips<>;
  int32_t node_ports<>;
  int32_t versions<>;
};

union control_sync_res switch (control_stat status) {
 case CONTROL_OK:
   control_sync_resok resok;
 default:
   void;
};

struct control_fetch_arg {
  bool hostlist;
  int32_t ip;
  int32_t port;
};

struct control_fetch_resok {
  opaque contents<>;
};

union control_fetch_res switch (control_stat status) {
  case CONTROL_OK:
    control_fetch_resok resok;
  default:
    void;
};



program CONTROL_PROGRAM {
  version CONTROL_VERSION {

    control_dist_res
    CONTROLPROC_DIST (control_dist_arg) = 0;

    control_sync_res
    CONTROLPROC_SYNC (control_sync_arg) = 1;    

    control_fetch_res
    CONTROLPROC_FETCH (control_fetch_arg) = 2;

  } = 1;
} = 400001;
