#!/usr/bin/perl -w

my $name;
my @args;

my $home = $ENV{PASTWATCH_ROOT};
if (!$home || $home eq "") { 
    $home = "$ENV{HOME}/.pastwatch";
}

my $view_arg = -1;
my $has_keyf = 0;

while ($#ARGV >= 0) {
  if ($ARGV[0] eq "-p") {
    push @args, $ARGV[0];
    push @args, $ARGV[1];

    $name = $ARGV[1];
    $mydir = "$home/$name";
    if (-d $mydir) { $view_arg = $#args; }
 
    shift @ARGV;
    shift @ARGV;
  }
  elsif ($ARGV[0] eq "-s") {
    push @args, $ARGV[0];
    push @args, $ARGV[1];
    $has_keyf = 1;
    shift @ARGV;
    shift @ARGV;
  }
  else {
    push @args, $ARGV[0];
    shift @ARGV;
  }
}

my $viewctl   = "pastprojctl";
my $pastwatch = "pastwatch";

if ($view_arg >= 0) {
    $mydir = "$home/$name";
    if (-l "$mydir/project.active") {
	$args [$view_arg] = "$mydir/project.active";
	if ($has_keyf == 0) {
	    my $keyf;
	    my $list = `$viewctl $mydir/project.active`;
	    my $vs = readlink "$mydir/project.active";
	    @list = split /\n/, $list;
	    
	    my @matchingkeys = ();
	    foreach $i (@list) {
		if (-r "$mydir/key.$i") {
		    push @matchingkeys, "$mydir/key.$i";
		}
	    }
	    if (scalar(@matchingkeys) == 1) {
		my @newargs;
		push @newargs, "-s";
		push @newargs, $matchingkeys[0];
		push @newargs, @args;
		@args = @newargs;
	    } elsif (scalar(@matchingkeys) > 1) {
		print STDERR "Multiple matching keys:\n";
		my $k;
		foreach $k (@matchingkeys) {
		    print STDERR "  $k\n";
		}
		print STDERR "Please select one using -s\n";
		exit(1);
	    }
	}
    }
}

exec $pastwatch, @args;

